#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################




if ($q->param('fct') eq "prev") ### GET TEMPLATE ID
	{
	$templates{'defdir'} = 1;
	$templates{'tmplsearch'} = 2;
	$templates{'tmplsearch_prem'} = 3;
	$templates{'subdirs'} = 4;
	$templates{'directories1'} = 5;
	$templates{'related1'} = 6;
	$templates{'related2'} = 7;
	$templates{'linkinfo'} = 8;
	$templates{'linkinfop'} = 9;
	
	$templates{'searchres'} = 10;
	$templates{'searchadv'} = 11;
	$templates{'lsearchres_loc'} = 12;
	$templates{'lsearchres_loc_prem'} = 13;
	$templates{'nomatch'} = 14;
	$templates{'flood'} = 15;
	
	$templates{'searchresdir'} = 16;
	$templates{'lsearchres_locdir'} = 17;
	
	$templates{'rate_it'} = 18;
	$templates{'rate_it_success'} = 19;
	$templates{'rate_it_fail'} = 20;
	$templates{'gethtml'} = 21;
	$templates{'review_it'} = 22;
	$templates{'reviewlinks'} = 23;
	$templates{'reviewadded'} = 24;
	$templates{'reviewproblem'} = 25;
	
	$templates{'whatsnew_main'} = 26;
	$templates{'whatsnew_lists'} = 27;
	$templates{'whatsnew_lists_prem'} = 28;
	
	$templates{'tophits_main'} = 29;
	$templates{'tophits_listings'} = 30;
	$templates{'tophits_listings_prem'} = 31;
	
	$templates{'brokenlink'} = 32;
	$templates{'brokenlink_success'} = 33;
	
	$templates{'mlist1'} = 34;
	$templates{'mlist2'} = 35;
	$templates{'mlist3'} = 36;
	
	### REG SYSTEM NOT IN USE TEMPLATES
	
	$templates{'add_url_med'} = 37;
	$templates{'add_url'} = 38;
	$templates{'add_url_medp'} = 40;
	$templates{'add_urlp'} = 39;
	$templates{'add_url_instructions'} = 41;
	$templates{'locked'} = 42;
	$templates{'add_url_problem'} = 43;
	$templates{'add_url_success'} = 44;

	$templates{'modify_link'} = 46;
	$templates{'modify_link_problem'} = 47;
	$templates{'modify_link_success'} = 48;
	
	$templates{'modify_link_edit'} = 49;
	$templates{'modify_link_editp'} = 50;
	$templates{'modify_instructions'} = 51;
	$templates{'retrievepass'} = 52;
	$templates{'retrievepass_ok'} = 53;
	$templates{'retrievepass_prb'} = 54;
	
	### REG SYSTEM TEMPLATES IN USE
	
	$templates{'rgs_msgregister'} = 55;
	$templates{'rgs_register'} = 56;
	
	$templates{'rgs_regsuccess'} = 57;
	$templates{'rgs_actsuccess'} = 58;
	$templates{'rgs_actfailed'} = 59;
	$templates{'rgs_resend'} = 60;
	$templates{'rgs_sent'} = 61;
	
	$templates{'rgs_login'} = 62;
	$templates{'rgs_logout'} = 63;
	
	$templates{'rgs_retrievepass'} = 64;
	$templates{'rgs_retrievepass_ok'} = 65;

	$templates{'rgs_cpmain'} = 66;
	$templates{'rgs_acclinks'} = 67;
	$templates{'rgs_acclinksp'} = 68;
	$templates{'rgs_nolinks'} = 69;
	
	$templates{'rgs_editacc'} = 70;
	$templates{'rgs_saveacc'} = 71;

	$templates{'rgs_add_url_med'} = 72;
	$templates{'rgs_add_url'} = 73;
	$templates{'rgs_add_url_medp'} = 74;
	$templates{'rgs_add_urlp'} = 75;
	$templates{'rgs_add_url_instructions'} = 76;
	$templates{'rgs_locked'} = 77;
	$templates{'rgs_add_url_problem'} = 78;
	$templates{'rgs_add_url_success'} = 79;
	
	$templates{'rgs_modify_link_edit'} = 86;
	$templates{'rgs_modify_link_editp'} = 87;
	$templates{'rgs_modify_link_problem'} = 88;
	$templates{'rgs_modify_link_success'} = 89;
	$templates{'rgs_modify_instructions'} = 90;
	
	$templates{'rgs_rcomment'} = 91;
	$templates{'rgs_rrate'} = 92;
	
	
	$templates{'fav_main'} = 93;
	$templates{'fav_standard'} = 94;
	$templates{'fav_premium'} = 95;
	$templates{'fav_none'} = 96;
	

	$objname = $q->param('template');
	
	$tmpl_id = $templates{$objname};
	}
	else
	{
	$tmpl_id = $q->param('id');
	}





if ($tmpl_id == 70) { &rgs_acc; } ### MAIN CONTROL PANEL ACC DETAILS / REG SYSTEM
if ($tmpl_id == 72) { &rgs_addurl(0, "medium"); } ### MAIN CONTROL PANEL ACC DETAILS / REG SYSTEM
if ($tmpl_id == 73) { &rgs_addurl(0, "large");; } ### MAIN CONTROL PANEL ACC DETAILS / REG SYSTEM|
if ($tmpl_id == 74) { &rgs_addurl(1, "medium"); } ### MAIN CONTROL PANEL ACC DETAILS / REG SYSTEM
if ($tmpl_id == 75) { &rgs_addurl(1, "large"); } ### MAIN CONTROL PANEL ACC DETAILS / REG SYSTEM

if ($tmpl_id == 86) { &rgs_mod_stan; } ### MODIFY LINK STANDARD
if ($tmpl_id == 87) { &rgs_mod_stan(1); } ### MODIFY LINK PREMIUM


print "Content-type: text/html\n\n";




if ($tmpl_id == 1) { &preview_defdir; }
if ($tmpl_id == 2) { &preview_defdir; }
if ($tmpl_id == 3) { &preview_defdir("PREMIUM"); }
if ($tmpl_id == 4) { &preview_defdir_subdir; }
if ($tmpl_id == 5) { &preview_defdir_subdir; }
if ($tmpl_id == 6) { &preview_defdir_related; }
if ($tmpl_id == 7) { &preview_defdir_related; }

if ($tmpl_id == 8) { &preview_linkinfo; }
if ($tmpl_id == 9) { &preview_linkinfop; }

if ($tmpl_id == 10) { &preview_search; }
if ($tmpl_id == 11) { &preview_searchadv; }
if ($tmpl_id == 12) { &preview_search; }
if ($tmpl_id == 13) { &preview_search_prem; }
if ($tmpl_id == 14) { &preview_nomatch; }
if ($tmpl_id == 15) { &preview_flood; }

if ($tmpl_id == 16) { &preview_dirsearch; }
if ($tmpl_id == 17) { &preview_dirsearch; }


if ($tmpl_id == 18) { &preview_rating; } ### RATING TEMPLATES
if ($tmpl_id == 19) { &preview_rated; }
if ($tmpl_id == 20) { &preview_ratefail; }
if ($tmpl_id == 21) { &preview_gethtmlcode; }


if ($tmpl_id == 22) { &preview_comments; } ### COMMENT/REVIEW
if ($tmpl_id == 23) { &preview_comments2; } 
if ($tmpl_id == 24) { &preview_comm_added; } 
if ($tmpl_id == 25) { &preview_comm_prob; } 

if ($tmpl_id == 26) { &preview_wnew; } ### WHATS NEW
if ($tmpl_id == 27) { &preview_wnew; }
if ($tmpl_id == 28) { &preview_wnew; }

if ($tmpl_id == 29) { &preview_pop; } ### POPULAR
if ($tmpl_id == 30) { &preview_pop; }
if ($tmpl_id == 31) { &preview_pop; }


if ($tmpl_id == 32) { &broken_links; } ### BROKEN LINKS
if ($tmpl_id == 33) { &broken_links_thanks; }

if ($tmpl_id == 34) { &subs1; } ### SUBSCRIPTION TEMPLATES
if ($tmpl_id == 35) { &subs2; } ### SUBSCRIPTION TEMPLATES
if ($tmpl_id == 36) { &subs3; } ### SUBSCRIPTION TEMPLATES


if ($tmpl_id == 37) { &add_url_medium; } ### ADD URL FORMS
if ($tmpl_id == 38) { &add_url_large; } ### ADD URL FORMS
if ($tmpl_id == 39) { &add_url_large(1); } ### ADD PREM URL FORMS
if ($tmpl_id == 40) { &add_url_medium(1); } ### ADD PREM URL FORMS
if ($tmpl_id == 41) { &add_url_instructions; } ### ADD URL INSTRUCTIONS
if ($tmpl_id == 42) { &add_url_locked; } ### CAT LOCKED
if ($tmpl_id == 43) { &add_url_problem; } ### ADD URL PROBLEM
if ($tmpl_id == 44) { &add_url_succ; } ### ADD URL SUCCESS

if ($tmpl_id == 46) { &mod_pass; } ### MODIFY PASSWORD
if ($tmpl_id == 47) { &mod_prob; } ### MODIFY PROBLEM
if ($tmpl_id == 48) { &mod_succ; } ### MODIFY SUCCESS
if ($tmpl_id == 49) { &mod_link_stand; } ### MODIFY EDIT STANDARD
if ($tmpl_id == 50) { &mod_link_stand(1); } ### MODIFY EDIT PREMIUM
if ($tmpl_id == 51) { &mod_instr; } ### MODIFY INSTRUCTIONS
if ($tmpl_id == 52) { &mod_ret1; } ### MODIFY PASS RETRIEVAL
if ($tmpl_id == 53) { &mod_ret2; } ### MODIFY PASS RETRIEVAL
if ($tmpl_id == 54) { &mod_ret3; } ### MODIFY PASS RETRIEVAL


if ($q->param('fct') eq "prev_cat") { &preview_defdir2; }
if ($q->param('fct') eq "search_keywords") { &search_keywords; }
if ($q->param('fct') eq "search_dirkeywords") { &search_dirkeywords; }

############## REGSITRATION SYSTEM

if ($tmpl_id == 55) { &register_msg; } ### REGISTRATION MESSAGE
if ($tmpl_id == 56) { &register_form; } ### REG FORM
if ($tmpl_id == 57) { &register_succ; } ### REG SUCCESS
if ($tmpl_id == 58) { &register_asucc; } ### ACTIVATION SUCCESS
if ($tmpl_id == 59) { &register_afail; } ### ACTIVATION FAILED
if ($tmpl_id == 60) { &register_resend; } ### ACTIVATION LINK RESEND
if ($tmpl_id == 61) { &register_sent; } ### ACTIVATION LINK SENT

if ($tmpl_id == 62) { &rgs_login; } ### LOGIN
if ($tmpl_id == 63) { &rgs_logout; } ### LOGOUT


if ($tmpl_id == 64) { &rgs_retrieve; } ### RETRIEVE PASS
if ($tmpl_id == 65) { &rgs_retrieve_succ; } ### PASSWORD RETRIEVED

if ($tmpl_id == 66) { &rgs_main; } ### MAIN CONTROL PANEL
if ($tmpl_id == 67) { &rgs_main; } ### MAIN CONTROL PANEL
if ($tmpl_id == 68) { &rgs_main2; } ### MAIN CONTROL PANEL
if ($tmpl_id == 69) { &rgs_nolinks; } ### MAIN CONTROL PANEL NO LINKS TEXT

if ($tmpl_id == 71) { &rgs_acc_saved; } ### SAVED ACC DETAILS  
if ($tmpl_id == 76) { &rgs_add_instr; } ### ADD URL INSTRUCTIONS
if ($tmpl_id == 77) { &rgs_locked; } ### LOCKED CAT
if ($tmpl_id == 78) { &rgs_add_prob; } ### ADD URL PROB
if ($tmpl_id == 79) { &rgs_add_succ; } ### ADD URL SUCCESS

if ($tmpl_id == 88) { &rgs_mod_prob; } ### MODIFY PROBLEM
if ($tmpl_id == 89) { &rgs_mod_succ; } ### MODIFY SUCCESS
if ($tmpl_id == 90) { &rgs_mod_instr; } ### MODIFY INSTRUCTIONS

if ($tmpl_id == 91) { &rgs_regcomm; } ### REG REQUIRED TO POST COMMENTS
if ($tmpl_id == 92) { &rgs_regrate; } ### REG REQUIRED TO POST COMMENTS

if ($tmpl_id == 93) { &favourites_prev; } ### REG REQUIRED TO POST COMMENTS
if ($tmpl_id == 94) { &favourites_prev; } ### REG REQUIRED TO POST COMMENTS
if ($tmpl_id == 95) { &favourites_prem_prev; } ### REG REQUIRED TO POST COMMENTS
if ($tmpl_id == 96) { &favourites_noprem; } ### REG REQUIRED TO POST COMMENTS



sub favourites_noprem
{
 	
$dtemplate = acs::get_file_contents("$data_dir/fav_main.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);


$no_fav_text = acs::get_file_contents("$data_dir/fav_none.html");

$dtemplate =~ s/!!favorites!!/$no_fav_text/g;
$dtemplate =~ s/%%favorites%%/$no_fav_text/g;

print $dtemplate;

}




sub favourites_prem_prev
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$todaytime = time();

$sql = "SELECT lnkid FROM links WHERE 	(
													((premium > '0') AND (subs_expire > '$todaytime')) 
														OR 
													((premium > '0') AND ((subs_expire IS NULL) OR (subs_expire = '0') OR (subs_expire = '')))
													)  LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1)
	{
print qq[	
	<ul>
	  <li class="normaltext">Could not preview this template because there is no 'Premium Link' available inside the database. Add a 'Premium Link' to be able to 'Preview' this template.  </li>
	</ul>
];
exit;
	}
	

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	}

$sth->finish;
$dbh->disconnect;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/favad.cgi?id=$lnkid">
</head>
<body>
</body>
</html>
];


}




sub favourites_prev
{

$query = new CGI;
$cookie_ids = $query->cookie('FavoriteLinks');

if ($cookie_ids !~ /[0-9]/)
{
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT lnkid FROM links WHERE premium IS NULL LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	}

$sth->finish;
$dbh->disconnect;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/favad.cgi?id=$lnkid">
</head>
<body>
</body>
</html>
];
}
else
{
print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/fav.cgi">
</head>
<body>
</body>
</html>
];

}



}



sub rgs_regrate
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_rrate.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;


}



sub rgs_regcomm
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_rcomment.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub rgs_mod_instr
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_modify_instructions.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub rgs_mod_succ
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_modify_link_success.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;



}




sub rgs_mod_prob
{

$rtext = acs::get_file_contents("$data_dir/regusers.txt"); 
@rtext = split (/\n/, $rtext);
$error_text = $rtext[4];

$dtemplate = acs::get_file_contents("$data_dir/rgs_modify_link_problem.html");
$dtemplate =~ s/%%problem%%/$error_text/g;
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;
}




sub rgs_mod_stan
{

my ($prem) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($prem > 0) 
	{
	$now = time();	
	$premsql = "AND (B.premium > 0) AND ((B.subs_expire > $now) OR (B.subs_expire = '')) "; 
	
	} 

$sql = "SELECT A.rgsuser, A.rgspass, B.cid, B.lnkid FROM lnkusers AS A, links AS B WHERE (A.userid = B.userid) AND (activated = 'Y') $premsql LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) 
	{
	print "Content-type: text/html\n\n";
	acs::problem_popup("You need at least one user account that has been activated with a premium link to preview this template."); exit; 
	}

while ( @row = $sth->fetchrow() )
	{
	$rgs_user = $row[0];
	$rgs_pass = $row[1];
	$cid = $row[2];
	$lnkid = $row[3];
	}

$sth->finish;
$dbh->disconnect;

	$query = new CGI;
	
	$thecookie1 = $query->cookie(-name=>'cpuser',
				    					  -value=>$rgs_user,
				    					  -expires=>'+24h',
				    					  -path=>'/');
	
	$thecookie2 = $query->cookie(	-name=>'cppass',
				    						-value=>$rgs_pass,
				    						-expires=>'+24h',
				    						-path=>'/');
	
	print $query->header(-cookie=>[$thecookie1, $thecookie2]); 

#print "Content-type: text/html\n\n";


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/modify2.cgi?cid=$cid&id=$lnkid">
</head>
<body>
</body>
</html>
];
exit;


}






sub rgs_add_succ
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_add_url_success.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;




}





sub rgs_add_prob
{

$rtext = acs::get_file_contents("$data_dir/regusers.txt"); 
@rtext = split (/\n/, $rtext);
$error_text = $rtext[4];

$dtemplate = acs::get_file_contents("$data_dir/rgs_add_url_problem.html");
$dtemplate =~ s/%%problem%%/$error_text/g;
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub rgs_locked
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_locked.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub rgs_add_instr
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_add_url_instructions.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub rgs_addurl
{

my ($prem, $formtype) = @_;



$gsettings = new_gsettings acs;

if (($gsettings->{add_url_form} eq "large") and ($formtype eq "medium"))
	{
	
	print "Content-type: text/html\n\n";

   $helpb = qq[<span class="normaltext"><b>Unable to Preview</b><BR><blockquote>
   
				 At the moment the 'Large' Add URL form is used for Large Search Engines. 
				 You have chosen to preview the 'Medium' sized 'Add URL' form. At present it is not in use
				 and for this reason is not available to be previewed.<BR>
				 <BR>
							 
				 You can change the use of large or medium 'Add URL' forms by clicking the 'Settings' tab 
				 >> Global Engine Settings >> 5. New Submission Settings >> Look for the setting reading:
				 What 'Add URL' form will you be using?<BR><BR>
							 
				 <b>Explanation of what the differences are between the two forms:</b><BR><BR>
					 
				 <b>Medium Sized Search Engine:</b> The 'add url' form for medium sized search engines, is recommended for search engines that is using less than 5000 directories. The directory tree is available as a drop down box on the submission form.<BR><BR>
					 
				 <b>Large Sized Search Engine:</b> The 'add url' form for large sized search engines is recommended for search engines that is using more than 5000 directories. The directory tree is not available as a drop down box on the submission form. Users have to go to the category where they would like to submit a new url and then click on the 'add url' link.
				 </blockquote>
				 ]; 
	print qq[<html><head><title></title><link href="$web_url/ps.css" rel="stylesheet" type="text/css"></head><body>$helpb;</body></html>];
	exit;

	}
	elsif (($gsettings->{add_url_form} eq "medium") and ($formtype eq "large"))
	{
	print "Content-type: text/html\n\n";
	
   $helpb = qq[
<span class="normaltext"><b>Unable to Preview</b><BR>
<BR><blockquote>
   						 
   						 At the moment the 'Medium' Add URL form is used for Medium Sized Search Engines. 
							 You have chosen to preview the 'Medium' sized 'Add URL' form. At present it is not in use
							 and for this reason is not available to be previewed.<BR>
							 <BR>
							 You can change the use of large or medium 'Add URL' forms by clicking the 'Settings' tab 
							 >> Global Engine Settings >> 5. New Submission Settings >> Look for the setting reading:
							 What 'Add URL' form will you be using?<BR>
							 <BR>
							 
							 <b>Explanation of what the differences are between the two forms:</b><BR><BR>
							 
							 <b>Medium Sized Search Engine:</b> The 'add url' form for medium sized search engines, is recommended for search engines that is using less than 5000 directories. The directory tree is available as a drop down box on the submission form.<BR>
							 <BR>
							 
							 <b>Large Sized Search Engine:</b> The 'add url' form for large sized search engines is recommended for search engines that is using more than 5000 directories. The directory tree is not available as a drop down box on the submission form. Users have to go to the category where they would like to submit a new url and then click on the 'add url' link.</span>
							 </blockquote>
							 ]; 
	print qq[<html><head><title></title><link href="$web_url/ps.css" rel="stylesheet" type="text/css"></head><body>$helpb;</body></html>];
	exit;
	}



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

### GET CATEGORY

$sql = "SELECT cid FROM dirs WHERE (catlock IS NULL) OR (catlock = '')";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();
if ($rows < 1) 
	{
	print "Content-type: text/html\n\n";
	acs::problem_popup("You need at least one category to preview this template."); exit; 
	}
	
while ( @row = $sth->fetchrow() ) { $cid = $row[0]; }

### GET USER ACC DETAILS

$sql = "SELECT A.* FROM lnkusers AS A, links AS B WHERE (A.userid = B.userid) LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) 
		{
		print "Content-type: text/html\n\n";
		acs::problem_popup("You11 need at least one user account with a link to preview this template."); exit; 
		}

while ( @row = $sth->fetchrow() )
	{
	$rgs_user = $row[1];
	$rgs_pass = $row[2];
	}

$sth->finish;
$dbh->disconnect;

	$query = new CGI;
	
	$thecookie1 = $query->cookie(-name=>'cpuser',
				    					  -value=>$rgs_user,
				    					  -expires=>'+24h',
				    					  -path=>'/');
	
	$thecookie2 = $query->cookie(	-name=>'cppass',
				    						-value=>$rgs_pass,
				    						-expires=>'+24h',
				    						-path=>'/');
	
	print $query->header(-cookie=>[$thecookie1, $thecookie2]); 

print "Content-type: text/html\n\n";

if ($prem > 0) { $crit = "p=1"; }

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/addurl.cgi?cid=$cid&$crit">
</head>
<body>
</body>
</html>
];

exit;


}







sub rgs_acc_saved
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_saveacc.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;



}





sub rgs_acc
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT A.* FROM lnkusers AS A, links AS B WHERE (A.userid = B.userid) LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) 
		{
		print "Content-type: text/html\n\n";
		acs::problem_popup("You need at least one user account with a link to preview this template."); exit; 
		}

while ( @row = $sth->fetchrow() )
	{
	$rgs_user = $row[1];
	$rgs_pass = $row[2];
	}

$sth->finish;
$dbh->disconnect;

	$query = new CGI;
	
	$thecookie1 = $query->cookie(-name=>'cpuser',
				    					  -value=>$rgs_user,
				    					  -expires=>'+24h',
				    					  -path=>'/');
	
	$thecookie2 = $query->cookie(	-name=>'cppass',
				    						-value=>$rgs_pass,
				    						-expires=>'+24h',
				    						-path=>'/');
	
	print $query->header(-cookie=>[$thecookie1, $thecookie2]); 

print "Content-type: text/html\n\n";
print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_adet.cgi">
</head>
<body>
</body>
</html>
];

exit;


}






sub rgs_nolinks
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$sql = "SELECT A.userid FROM lnkusers AS A, links AS B WHERE (A.userid = B.userid) AND A.activated = 'Y'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}

while ( @row = $sth->fetchrow() )
	{
	push (@lnk_uids, $row[0]);
	}


$sql = "SELECT userid FROM lnkusers";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}

while ( @row = $sth->fetchrow() )
	{
	
	if ($nolinks eq "")
	 {
		foreach $item (@lnk_uids)
		{
			if ($item != $row[0])
				{
				$nolinks = $row[0];
				}
		}
	 }

	}


if ($nolinks eq "") 
	{

print qq[
	<html>
	<head>
	<title>PowerSeek</title>
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
	</head>
	<body>

	<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
	<p><strong>This may be due to the following reasons:
	</strong>
	<ul>
	  <li class="normaltext">The database contains no links. If so then add some links and categories.</li>
	  <li class="normaltext">There are no user accounts. Create a user account. You can create a user account by <a href="$script_url/rgs_register.cgi" target="_blank">clicking here.</a></li>
	  <li class="normaltext">There is at least one user account but there isn't a user account that contains no links.</li>
    </ul>

	</body>
</html>
];	
	
	$sth->finish;
	$dbh->disconnect;
	}
	
	

$sql = "SELECT * FROM lnkusers WHERE userid = '$nolinks'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("You need at least one user account with a link to preview this template."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$rgs_user = $row[1];
	$rgs_pass = $row[2];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_login.cgi?rgs_user=$rgs_user&rgs_pass=$rgs_pass">
</head>
<body>
</body>
</html>
];

}




sub rgs_main2
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$now = time();
$sql = "SELECT A.* FROM lnkusers AS A, links AS B WHERE (A.userid = B.userid) AND (premium > 0) AND ((subs_expire > $now) OR (subs_expire = '')) LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("You need at least one user account with a premium link to preview this template."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$rgs_user = $row[1];
	$rgs_pass = $row[2];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_login.cgi?rgs_user=$rgs_user&rgs_pass=$rgs_pass">
</head>
<body>
</body>
</html>
];


}





sub rgs_main
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT A.* FROM lnkusers AS A, links AS B WHERE (A.userid = B.userid) AND (B.premium < '1') LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("You need at least one user account with a at least one link to preview this template."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$rgs_user = $row[1];
	$rgs_pass = $row[2];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_login.cgi?rgs_user=$rgs_user&rgs_pass=$rgs_pass">
</head>
<body>
</body>
</html>
];





}





sub rgs_retrieve_succ
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_retrievepass_ok.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}



sub rgs_retrieve
{

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_repass.cgi">
</head>
<body>
</body>
</html>
];


}




sub rgs_logout
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_logout.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate =~ s/!!error_text!!//g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub rgs_login
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_login.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate =~ s/!!error_text!!//g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}







sub register_sent
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_sent.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;



}




sub register_resend
{


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_resend.cgi">
</head>
<body>
</body>
</html>
];


}




sub register_afail
{
$rtext = acs::get_file_contents("$data_dir/regusers.txt"); 
@rtext = split (/\n/, $rtext);
$error_text = $rtext[0];


$dtemplate = acs::get_file_contents("$data_dir/rgs_actfailed.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate =~ s/!!error_text!!/$rtext[20]/g;
$dtemplate =~ s/!!rgs_resendact!!/$script_url\/rgs_resend.cgi/g;


$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}








sub register_asucc
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_actsuccess.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub register_succ
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_regsuccess.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;


}






sub register_form
{


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_register.cgi">
</head>
<body>
</body>
</html>
];


}



sub register_msg
{

$dtemplate = acs::get_file_contents("$data_dir/rgs_msgregister.html");
$dtemplate =~ s/!build_url!/$web_url/g;

$dtemplate =~ s/!!account_create!!/$script_url\/register\.cgi/g;

$dtemplate =~ s/!!retreive_password!!/$script_url\/rgs_repass\.cgi/g;

$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}






sub mod_ret3
{

$dtemplate = acs::get_file_contents("$data_dir/retrievepass_prb.html");
$dtemplate =~ s/!build_url!/$web_url/g;

$dtemplate =~ s/!!email_script!!/$script_url\/modify5\.cgi/g;

$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub mod_ret2
{

$dtemplate = acs::get_file_contents("$data_dir/retrievepass_ok.html");
$dtemplate =~ s/!build_url!/$web_url/g;

$dtemplate =~ s/!!email_script!!/$script_url\/modify5\.cgi/g;

$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub mod_ret1
{

$dtemplate = acs::get_file_contents("$data_dir/retrievepass.html");
$dtemplate =~ s/!build_url!/$web_url/g;

$dtemplate =~ s/!!email_script!!/$script_url\/modify5\.cgi/g;

$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}






sub mod_instr
{

$dtemplate = acs::get_file_contents("$data_dir/modify_instructions.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub mod_link_stand
{
my ($prem) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES
$now = time();
if ($prem ne "") { $psql = "AND (premium > 0) AND ((subs_expire > $now) OR (subs_expire = ''))"; } 
else
{ $psql = "AND ((premium IS NULL) OR (premium < 1))"; } 


$sql = "SELECT lnkid, cid, lnkpassword FROM links WHERE (lnkpassword IS NOT NULL) AND (lnkpassword != '') $psql LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

	if ($prem eq "") 
		{
		if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview this template. If you have links inside your database then make sure that at least one has a modify password."); exit; }
		}
		else
		{
		if ($rows < 1) { acs::problem_popup("To preview this template, you need a premium link with has a modify password."); exit; }
		}


while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	$mpass = $row[2];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/modify2.cgi?id=$lnkid&cid=$cid&password=$mpass">
</head>
<body>
</body>
</html>
];


}







sub mod_succ
{

$dtemplate = acs::get_file_contents("$data_dir/modify_link_success.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub mod_prob
{

$rtext = acs::get_file_contents("$data_dir/modify2.txt"); 
@rtext = split (/\n/, $rtext);
$error_text = $rtext[0];

$commproblem = acs::get_file_contents("$data_dir/modify_link_problem.html");
$commproblem =~ s/!build_url!/$web_url/g;
$commproblem =~ s/%%problem%%/$error_text/g;

$commproblem = acs::ts_insert_template_includes($commproblem);
$commproblem = acs::fill_vars($commproblem);
print $commproblem;


}




sub mod_pass
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT lnkid, cid FROM links WHERE (cid IS NOT NULL) OR (cid > 0) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/modify.cgi?id=$lnkid&cid=$cid">
</head>
<body>
</body>
</html>
];


}




sub add_url_succ
{

$dtemplate = acs::get_file_contents("$data_dir/add_url_success.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub add_url_problem
{

$rtext = acs::get_file_contents("$data_dir/addurl2.txt"); 
@rtext = split (/\n/, $rtext);
$error_text = $rtext[0];

$commproblem = acs::get_file_contents("$data_dir/add_url_problem.html");
$commproblem =~ s/!build_url!/$web_url/g;
$commproblem =~ s/%%problem%%/$error_text/g;

$commproblem = acs::ts_insert_template_includes($commproblem);
$commproblem = acs::fill_vars($commproblem);
print $commproblem;




}





sub add_url_locked
{

$dtemplate = acs::get_file_contents("$data_dir/locked.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub add_url_instructions
{

$dtemplate = acs::get_file_contents("$data_dir/add_url_instructions.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub add_url_medium
{

my ($prem) = @_;

$gsettings = new_gsettings acs;

if ($gsettings->{add_url_form} ne "medium") 
	{
print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
<p><strong>Unable to Preview</strong></p>
<blockquote>
  <p>This template is currently not in use and for that reason cannot be previewed. The 'Large Sized' Search Engine Add URL forms are currently used.<BR>
    <BR>
    There are two types of Add URL forms available for use. You can use the Medium-Sized or Large-Sized Search Engine Add URL Forms. The differences between the two are as follows:<BR>
  <BR>
  <b>Medium-Sized Search Engines Add URL Forms</b>
    The 'Add URL' form for medium sized search engines, is recommended for search engines that is using less than 5000 directories/categories. The directory tree is available as a dropdown box in the Add URL form. This means that end-users do not have to browse to a directory/category and click the 'Add URL' button or link to add a URL to a specific category.
  <BR>
  <BR>
  <b>Large-Sized Search Engines Add URL Forms</b>
    The Add URL form for large sized search engines is recommended for search engines that are using more than 5000 directories/categories. The directory tree is not available as a dropdown box in the Add URL form. Users have to go to the category where they would like to submit a new URL and then click on the Add URL link.
  <BR>
  <BR>
    To choose what ADD URL forms or templates should be used, go to the Control Panel. Then click on the Settings tab. Now click the 'Global Engine Settings' links. Look for a setting that reads: 'What 'Add URL' form will you be using?'
  </p>
</blockquote>
</body>
</html>
];

	
	exit;
	}



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT cid FROM dirs WHERE (catlock IS NULL) OR (catlock = 'N') OR (catlock = '') LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$cid = $row[0];
	}

$sth->finish;
$dbh->disconnect;

if ($prem ne "") { $crit = "p=1"; }

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/addurl.cgi?cid=$cid&$crit">
</head>
<body>
</body>
</html>
];

}





sub add_url_large
{

my ($prem) = @_;

$gsettings = new_gsettings acs;

if ($gsettings->{add_url_form} ne "large") 
	{

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
<p><strong>Unable to Preview</strong></p>
<blockquote>
  <p>This template is currently not in use and for that reason cannot be previewed. The 'Large Sized' Search Engine Add URL forms are currently used.<BR>
    <BR>
    There are two types of Add URL forms available for use. You can use the Medium-Sized or Large-Sized Search Engine Add URL Forms. The differences between the two are as follows:<BR>
  <BR>
  <b>Medium-Sized Search Engines Add URL Forms</b>
    The 'Add URL' form for medium sized search engines, is recommended for search engines that is using less than 5000 directories/categories. The directory tree is available as a dropdown box in the Add URL form. This means that end-users do not have to browse to a directory/category and click the 'Add URL' button or link to add a URL to a specific category.
  <BR>
  <BR>
  <b>Large-Sized Search Engines Add URL Forms</b>
    The Add URL form for large sized search engines is recommended for search engines that are using more than 5000 directories/categories. The directory tree is not available as a dropdown box in the Add URL form. Users have to go to the category where they would like to submit a new URL and then click on the Add URL link.
  <BR>
  <BR>
    To choose what ADD URL forms or templates should be used, go to the Control Panel. Then click on the Settings tab. Now click the 'Global Engine Settings' links. Look for a setting that reads: 'What 'Add URL' form will you be using?'
  </p>
</blockquote>
</body>
</html>];
exit;
	}



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT cid FROM dirs WHERE (catlock IS NULL) OR (catlock = 'N') OR (catlock = '') LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$cid = $row[0];
	}

$sth->finish;
$dbh->disconnect;

if ($prem ne "") { $crit = "p=1"; }


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/addurl.cgi?cid=$cid&$crit">
</head>
<body>
</body>
</html>
];

}






sub subs3
{

$dtemplate = acs::get_file_contents("$data_dir/mlist3.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}



sub subs2
{

$dtemplate = acs::get_file_contents("$data_dir/mlist2.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}




sub subs1
{

$dtemplate = acs::get_file_contents("$data_dir/mlist1.html");
$dtemplate =~ s/!build_url!/$web_url/g;
$dtemplate =~ s/!!removalscript!!/$script_url\/unsubscribe\.cgi/g;
$dtemplate = acs::ts_insert_template_includes($dtemplate);
$dtemplate = acs::fill_vars($dtemplate);
print $dtemplate;

}





sub broken_links_thanks
{

$commproblem = acs::get_file_contents("$data_dir/brokenlink_success.html");
$commproblem =~ s/!build_url!/$web_url/g;
$commproblem = acs::ts_insert_template_includes($commproblem);
$commproblem = acs::fill_vars($commproblem);

$commproblem =~ s/!!category_with_link!!/Replaced with categories \.\.\./gi;
$commproblem =~ s/!!title_without_link!!/Replaced by title of link \.\.\./gi;

print $commproblem;

}




sub broken_links
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT lnkid, cid FROM links WHERE (cid IS NOT NULL) OR (cid > 0) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rprtb.cgi?id=$lnkid&cid=$cid">
</head>
<body>
</body>
</html>
];




}






sub preview_pop
{

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs.cgi?newpop=pop">
</head>
<body>
</body>
</html>
];


}



sub preview_wnew
{

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs.cgi?newpop=new">
</head>
<body>
</body>
</html>
];



}








sub preview_comm_prob
{

$rtext = acs::get_file_contents("$data_dir/reviews2.txt"); 
@rtext = split (/\n/, $rtext);
$error_text = $rtext[0];

$commproblem = acs::get_file_contents("$data_dir/reviewproblem.html");
$commproblem =~ s/!build_url!/$web_url/g;
$commproblem =~ s/%%problem%%/$error_text/g;

$commproblem = acs::ts_insert_template_includes($commproblem);
$commproblem = acs::fill_vars($commproblem);

$commproblem =~ s/!!category_with_link!!/Replaced with categories \.\.\./gi;
$commproblem =~ s/!!title_without_link!!/Replaced by title of link \.\.\./gi;


print $commproblem;




}




sub preview_comm_added
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
			    FROM links AS A, dirs AS B 
		       WHERE (A.cid = B.cid) LIMIT 0,1
");

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();


if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

$ratesucc = acs::get_file_contents("$data_dir/reviewadded.html"); 

while ( @row = $sth->fetchrow() )
	{

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		}

	$cats = qq[<a href="$script_url/dirs2.cgi?cid=$row[16]">$cats</a>];
	$ratesucc =~ s/!!category!!/$cats/gi;

	$rating_image = &get_rating_images2($row[27]);
	$ratesucc =~ s/!!rating_image!!/$rating_image/gi;
	
	
	$titlewl = qq[<a href="$row[22]">$row[19]</a> ];
	$ratesucc =~ s/!!title_with_link!!/$titlewl/gi;
	
	$ratesucc =~ s/!!description!!/$row[20]/gi;
	$ratesucc =~ s/!!url!!/$row[22]/gi;
	$ratesucc =~ s/!!rating!!/$row[27]/gi;
	$ratesucc =~ s/!!votes!!/$row[28]/gi;
	$ratesucc =~ s/!!hits!!/$row[29]/gi;
	
	$dd = acs::decode_date($row[34]);
	$ratesucc =~ s/!!date!!/$dd/gi;
	}

$sth->finish;
$dbh->disconnect;


$ratesucc = acs::ts_insert_template_includes($ratesucc);
$ratesucc = acs::fill_vars($ratesucc);


$ratesucc =~ s/!!category_with_link!!/Replaced with categories \.\.\./gi;
$ratesucc =~ s/!!title_without_link!!/Replaced by title of link \.\.\./gi;

print $ratesucc;



}






sub preview_comments2
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT A.lnkid, A.cid, B.review FROM links AS A, reviews AS B WHERE (B.lnkid = A.lnkid) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("At least one link inside your database needs a review/comment to preview this template."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/reviews.cgi?id=$lnkid&cid=$cid">
</head>
<body>
</body>
</html>
];



}





sub preview_comments
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT lnkid, cid FROM links WHERE (cid IS NOT NULL) OR (cid > 0) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/reviews.cgi?id=$lnkid&cid=$cid">
</head>
<body>
</body>
</html>
];


}





sub preview_gethtmlcode
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT lnkid, cid FROM links WHERE (cid IS NOT NULL) OR (cid > 0) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/gethtml.cgi?id=$lnkid&cid=$cid">
</head>
<body>
</body>
</html>
];




}







sub preview_ratefail
{

$rateit_template = acs::get_file_contents("$data_dir/rate_it_fail.html");
$rateit_template =~ s/!build_url!/$web_url/g;

$rateit_template = acs::ts_insert_template_includes($rateit_template);
$rateit_template = acs::fill_vars($rateit_template);


$rateit_template =~ s/!!category_with_link!!/Replaced with categories \.\.\./gi;
$rateit_template =~ s/!!title_without_link!!/Replaced by title of link \.\.\./gi;

print $rateit_template;

}






sub preview_rated
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
			    FROM links AS A, dirs AS B 
		       WHERE (A.cid = B.cid) LIMIT 0,1
");

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();


if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

$ratesucc = acs::get_file_contents("$data_dir/rate_it_success.html"); 

while ( @row = $sth->fetchrow() )
	{

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		}

	$cats = qq[<a href="$script_url/dirs2.cgi?cid=$row[16]">$cats</a>];
	$ratesucc =~ s/!!category!!/$cats/gi;

	$rating_image = &get_rating_images2($row[27]);
	$ratesucc =~ s/!!rating_image!!/$rating_image/gi;
	
	
	$titlewl = qq[<a href="$row[22]">$row[19]</a> ];
	
	$otitle = $row[19];
	$ratesucc =~ s/!!title_with_link!!/$titlewl/gi;
	
	$ratesucc =~ s/!!description!!/$row[20]/gi;
	$ratesucc =~ s/!!url!!/$row[22]/gi;
	$ratesucc =~ s/!!rating!!/$row[27]/gi;
	$ratesucc =~ s/!!votes!!/$row[28]/gi;
	$ratesucc =~ s/!!hits!!/$row[29]/gi;
	
	$dd = acs::decode_date($row[34]);
	$ratesucc =~ s/!!date!!/$dd/gi;
	}

$sth->finish;
$dbh->disconnect;


$ratesucc = acs::ts_insert_template_includes($ratesucc);
$ratesucc = acs::fill_vars($ratesucc);


$ratesucc =~ s/!!category_with_link!!/$cats/gi;
$ratesucc =~ s/!!title_without_link!!/$otitle/gi;

print $ratesucc;



}




sub get_rating_images2
{
my ($rating) = @_;
my ($image_rate, $decm, $images);

	if ($rating > 0)
			{
			($image_rate, $decm) = split (/\./, $rating);
		
			if (length($decm) == 1)
				{
				if ($decm > 4) {$image_rate++;}
				}
			if (length($decm) == 2)
				{
				if ($decm > 49) {$image_rate++;}
				}
		
			$image_rate = "r" . $image_rate . ".gif";
			$image_rate =~ s/ //g;
			$images = "<img src=\"$web_url/$image_rate\">";
			}

return ($images); 
}









sub preview_rating
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT lnkid, cid FROM links WHERE (cid IS NOT NULL) OR (cid > 0) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	$cid = $row[1];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rateit.cgi?id=$lnkid&cid=$cid">
</head>
<body>
</body>
</html>
];





}






sub search_dirkeywords
{

$cat_keywords = $q->param('keywords');

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirsearch.cgi?cat_keywords=$cat_keywords&mtype=internal">
</head>
<body>
</body>
</html>
];


}







sub preview_dirsearch
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM dirs ORDER BY level DESC LIMIT 0,1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

while ( @row = $sth->fetchrow() )
	{
		$acnt = 0;
		for ($ms = 2; $ms < 18; $ms++) 
			{
			if ($row[$ms] ne "")
				{
				push (@charr, $row[$ms]);
				$acnt++;
				}
			}
	

	}

$sth->finish;
$dbh->disconnect;


if ($rows < 1)
	{

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
	<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
		
		<p><strong>This may be due to the following reasons:
		</strong>
	<ul>
	  <li class="normaltext">You have no categories. Add some categories from the 'Dir Manager'</li>
    </ul>
	</body>
</html>
];
exit;	
	
	}


$charr[0] =~ s/ /+/gi;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin68.cgi?keywords=$charr[0]&fct=search_dirkeywords">
</head>
<body>
</body>
</html>
];
exit;



print qq[

<html>

<head>
<title>PowerSeek</title>
</head>

<body>

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/ic_pr.gif"></td>
    <td width="95%" valign="top"><font face="Arial" size="4"><strong>Specify Search Keywords
    to Preview the Directory Search Templates:</strong></font><form method="POST"
    action="$admin_url/admin68.cgi">
      <input type="hidden" name="fct" value="search_dirkeywords"><p><font face="Verdana" size="1">Keywords:</font>
      <input type="text" name="keywords" size="36"> <input type="submit" value="   Preview   "
      name="go"></p>
    </form>
    <p><strong><font face="Verdana" size="1">Notes:</font></strong><ul>
      <li><font face="Verdana" size="1">Enter a keyword above that you know is available in a
        directory/category name.<br>
        &nbsp; &nbsp; </font></li>
    </ul>
    </td>
  </tr>
</table>

<p><br>
</p>

<hr noshade size="1" color="#F2F2F2" align="center">
</body>
</html>

];

}






sub preview_flood
{

$flood = acs::get_file_contents("$data_dir/flood.html"); 

print $flood;

}







sub preview_nomatch
{

$keywords = "asdniweuwerwerhuhsrds";


$gsettings = new_gsettings acs;

if ($gsettings->{searchmeth} eq "fulltext") 
	{
	$searchl = "search2.cgi?keywords=$keywords";
	}
	else
	{
	$searchl = "search.cgi?keywords=$keywords";
	}



print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/$searchl">
</head>
<body>
</body>
</html>
];


}







sub preview_searchadv
{


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/searchadv.cgi">
</head>
<body>
</body>
</html>
];


}








sub search_keywords
{

$keywords = $q->param('keywords');


$gsettings = new_gsettings acs;

$keywords =~ s/ /+/g;

if ($gsettings->{searchmeth} eq "fulltext") 
	{
	$searchl = "search2.cgi?keywords=$keywords";
	}
	else
	{
	$searchl = "search.cgi?keywords=$keywords";
	}


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/$searchl">
</head>
<body>
</body>
</html>
];

}




sub preview_search_prem
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$nowtoday = time();

$sql = "SELECT title,description, keywords FROM links WHERE 
																				((subs_expire > '$nowtoday') AND (premium > 0))
																				OR ((subs_expire IS NULL) AND (premium > 0))
																				OR ((subs_expire = '') AND (premium > 0))
																				LIMIT 0,1";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();


if ($rows < 1)
	{
print qq[
	<html>
	<head>
	<title>PowerSeek</title>
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
	</head>
	<body>
	

	<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
		
		<p><strong>This may be due to the following reasons:
		</strong>
	<ul>
	  <li class="normaltext">You have no links inside the database. Add some categories and links.</li>
	  <li class="normaltext">You only have a handful of links. For the PowerSeek search to function properly you at least need 20 or more links.</li>
    </ul>
	
	</body>
</html>
];
exit;
	}


$search_crit = "";
while ( @row = $sth->fetchrow() )
	{
	$search_crit = "";
	$row[2] =~ s/,/ /g;
	$search_crit = $search_crit . $row[0] . " " . $row[1] . " " . $row[2];
	}

$sth->finish;
$dbh->disconnect;


@search_kw = split (/ /, $search_crit);

$incnt = 0;
foreach $item (@search_kw)
	{
		if (length($item) > 3)
		{
			if ($incnt < 4) 
				{
				$to_search = $to_search . $item . " ";
				}
			$incnt++;
		}
	
	}

$to_search =~ s/ /+/gi;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin68.cgi?keywords=$to_search&fct=search_keywords">
</head>
<body>
</body>
</html>
];



}




sub preview_search
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$sql = "SELECT title,description, keywords FROM links LIMIT 0,1";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();


if ($rows < 1)
	{
print qq[
	<html>
	<head>
	<title>PowerSeek</title>
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
	</head>
	<body>
	

	<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
		
		<p><strong>This may be due to the following reasons:
		</strong>
	<ul>
	  <li class="normaltext">You have no links inside the database. Add some categories and links.</li>
	  <li class="normaltext">You only have a handful of links. For the PowerSeek search to function properly you at least need 20 or more links.</li>
    </ul>
	
	</body>
</html>
];
exit;
	}


$search_crit = "";
while ( @row = $sth->fetchrow() )
	{
	$search_crit = "";
	$row[2] =~ s/,/ /g;
	$search_crit = $search_crit . $row[0] . " " . $row[1] . " " . $row[2];
	}

$sth->finish;
$dbh->disconnect;


@search_kw = split (/ /, $search_crit);

$incnt = 0;
foreach $item (@search_kw)
	{
		if (length($item) > 3)
		{
			if ($incnt < 6) 
				{

				$inv_char = "";
				for ($ms = 0; $ms < length($item); $ms++) 
					{
						$oneletter = substr($item, $ms, 1);
						if (($oneletter !~ /[0-9a-zA-Z]/))
						{
							$inv_char = "yes";
						}
					}

				if ($inv_char ne "yes") {$to_search = $to_search . $item . " ";}
				}
			$incnt++;
		}
	
	}

$to_search =~ s/ /+/gi;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin68.cgi?keywords=$to_search&fct=search_keywords">
</head>
<body>
</body>
</html>
];


}







sub preview_linkinfop
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT A.lnkid FROM links AS A, dirs AS B WHERE (A.premium > '0') AND (A.cid = B.cid) AND ((B.template = '') OR (B.template IS NULL)) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("To be able to preview this template, add at least one premium link in the Dir Manager."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/linfo.cgi?id=$lnkid">
</head>
<body>
</body>
</html>
];


}




sub preview_linkinfo
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT A.lnkid FROM links AS A, dirs AS B WHERE ((A.premium < '1') OR (A.premium IS NULL)) AND (A.cid = B.cid) AND ((B.template = '') OR (B.template IS NULL)) LIMIT 0,1");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("Add a least one category and link in the Dir Manager before you preview templates."); exit; }

while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[0];
	}

$sth->finish;
$dbh->disconnect;


print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/linfo.cgi?id=$lnkid">
</head>
<body>
</body>
</html>
];


}







sub preview_defdir2
{

$cid = $q->param('category_dropdown');

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs2.cgi?cid=$cid">
</head>
<body>
</body>
</html>
];

}





sub preview_defdir_related
{

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES WITH SUBDIRS

$sqlr = "SELECT * FROM dirs WHERE 	((crosslinkid IS NULL) OR (crosslinkid < 1)) AND 
												((template IS NULL) OR (template = '')) AND 
												(catlock != 'H') AND (related1 > '') AND (related1 IS NOT NULL)
												
												ORDER BY linknrs DESC LIMIT 0, 1";



$sth = $dbh->prepare($sqlr);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n";}
$rows = $sth->rows();

if ($rows < 1)
	{
	print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>

<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
	
	<p><strong>This may be due to the following reasons:
	</strong>
<ul>
  <li class="normaltext">You don't have any related categories listed with categories. To add  related categories to an existing category edit an existing category (from the Dir Manager tab) and assign related categories to it.</li>
  <li class="normaltext">It may also be that you have categories that has related categories but none of those categories are using the default category template. (The categories that has related categories may be using a custom category template set)</li>
</ul>

</body>
</html>
	];
	exit;
	}

while ( @row = $sth->fetchrow() )
	{
	$cid = $row[0];
	}


$sth->finish;
$dbh->disconnect;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs2.cgi?cid=$cid">
</head>
<body>
</body>
</html>
];

}





sub preview_defdir_subdir
{

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES WITH SUBDIRS

$sqlr = "SELECT * FROM dirs WHERE 	((crosslinkid IS NULL) OR (crosslinkid < 1)) AND 
												((template IS NULL) OR (template = '')) AND 
												(catlock != 'H') AND (level = '1') 
												 ORDER BY linknrs DESC LIMIT 0, 1";



$sth = $dbh->prepare($sqlr);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n";}
$rows = $sth->rows();

if ($rows < 1)
	{
	print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>

<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
	
	<p><strong>This may be due to the following reasons:
	</strong>
<ul>
  <li class="normaltext">You don't have a category that has a sub category. Add a category that contains some sub categories.</li>
  </ul>


</body>
</html>
	];
	exit;
	}

while ( @row = $sth->fetchrow() )
	{
	$cid = $row[0];
	}


$sth->finish;
$dbh->disconnect;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs2.cgi?cid=$cid">
</head>
<body>
</body>
</html>
];



}





sub preview_defdir
{

my ($prem_lnk) = @_;

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

if ($prem_lnk ne "") 
	{
	$nowtime = time();
	$prem_lnk_sql = "AND ((B.premium > 0) AND ((B.subs_expire > '$nowtime') OR (B.subs_expire = '') OR (B.subs_expire IS NULL))  ) ";
	}


$sqlr = "SELECT A.cid, B.lnkid FROM dirs AS A, 
								 links AS B 
								WHERE 	((A.crosslinkid IS NULL) OR (A.crosslinkid < 1)) AND 
											((A.template IS NULL) OR (A.template = '')) AND 
											(A.catlock != 'H') AND (A.cid = B.cid) AND
											(A.linknrs > 0) $prem_lnk_sql
											ORDER BY linknrs DESC LIMIT 0, 1";

$sth = $dbh->prepare($sqlr);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n";}
$rows = $sth->rows();



if ($rows < 1)
	{
	print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
<p><font color="#FF0000"><strong>Problem - Unable to Preview:</strong></font></p>
	
	<p><strong>This may be due to the following reasons:
	</strong>
<ul>
  <li class="normaltext">You don't have any categories or links inside the Directory. To add categories 
    or links click the 'Dir Manager' tab. Then add categories/directories and links.<br>
  </li>
  <li class="normaltext">No categories are using the default category/directory template set. (All 
	    categories might be using a custom Category/Directory template set.) If you don't 
    know what Category/Directory templates sets are then this is most likely not the case.</li>
  <li class="normaltext">You have categories inside the Directories but no links.</li>
  <li class="normaltext">If you are previewing the 'Premium Link Style' template then it may be that your Directory has no premium links and thus creating a situation where such a preview cannot be displayed.</li>
</ul>
</body>
</html>
	];
	exit;
	}

while ( @row = $sth->fetchrow() )
	{
	$cid = $row[0];
	$lnkid = $row[1];
	}


$sth->finish;
$dbh->disconnect;

print qq[
<html>
<head>
<title>FocalMedia.Net</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs2.cgi?cid=$cid">
</head>
<body>
</body>
</html>
];


}







sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

